<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Banner extends MX_Controller {

	// Deny direct access
	function _remap()
	{
		show_404();
	}

	public function __construct() {
		parent::__construct();
		$this->load->model('banner_model');
		$this->load->helper(array('form', 'url'));
	}

	public function index()
	{
		$pageData['title']		= 'Dvee';
		$pageData['avatar']		= '<img src="'.base_url().$this->session->userdata('avatar').'" />';
		$pageData['username']	= $this->session->userdata('username');
		$pageData['banners']	= $this->banner_model->get_banners();
		$pageData['categories']	= $this->banner_model->get_categories();
		$pageData['slides']		= $this->banner_model->get_slides();

		$this->load->view('banner_view', $pageData);
	}

	public function add_banners()
	{
		if (!isset($_SESSION)) {
			session_start();
		}
		if ($this->banner_model->upload_banners() == true) {
			$_SESSION['banner_success'] = true;
			session_write_close();
			header("location: ".base_url()."panel/banners");
		} else {
			$_SESSION['banner_success'] = false;
			session_write_close();
			header("location: ".base_url()."panel/banners");
		}
	}

	public function delete_banner($ID = false)
	{
		$this->banner_model->delete_banner($ID);
	}

	public function add_slides()
	{
		if (!isset($_SESSION)) {
			session_start();
		}
		if ($this->banner_model->upload_slides() == true) {
			$_SESSION['slide_success'] = true;
			session_write_close();
			header("location: ".base_url()."panel/banners");
		} else {
			$_SESSION['slide_success'] = false;
			session_write_close();
			header("location: ".base_url()."panel/banners");
		}
	}

	public function delete_slide($ID = false)
	{
		$this->banner_model->delete_slide($ID);
	}
}