<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Create extends MX_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->helper('form');
		$this->load->model('create_model');
	}

	public function index()
	{
		if ($this->db->table_exists('store'))	{
			// store exists, redirect to login page
			header("location: ".base_url()."panel.html");
		} else {
			$this->load->view('create_view');
		}
	}

	public function upload()
	{
		$formErrors = array();

		if( isset($_POST)) {

			if ( ! empty($_POST)) {

				// check that the passwords match
				if ($_POST['password1'] === $_POST['password2']) {

					$storeName 		= $this->input->post("name");
					$password 		= $this->input->post("password1");
					$emailAddress 	= $this->input->post("mail");
					$slogan 		= $this->input->post('slogan');
					$phoneNumber1	= $this->input->post('phone1');
					$phoneNumber2 	= $this->input->post('phone2');
					$twitter 		= $this->input->post('twitter');
					$facebook 		= $this->input->post('facebook');
					$google 		= $this->input->post('google');

					if (isset($_POST['home'])) {

						$physicalAddress = $this->input->post('home');
						
						// use the location to get geocode values
						$geocode = @file_get_contents(
						'http://maps.google.com/maps/api/geocode/json?address='
						.str_replace(" ", "+", $physicalAddress)
						.'&sensor=false');
						
						// ensure that the api returns content
						if ($geocode === false) {
							$latitude  = false;
							$longitude = false;
						} else {
							$output    = json_decode($geocode);

							// google api doesn't produce geocode
							if ($output->status == "ZERO_RESULTS" ) {
								$latitude  = false;
								$longitude = false;
							} else {
								$latitude  = $output->results[0]->geometry->location->lat;
								$longitude = $output->results[0]->geometry->location->lng;
							}
						}
					} else {
						$physical_address = "";
					}

					// Ensure that an upload file was submitted
					if (isset($_FILES)) {

						if ( is_array($path = $this->upload_image())) {
							// Errors occured during upload
							foreach ($path as $key => $value) {
								array_push($formErrors, $value);
							}
						}

						// No form errors recorded
						if ( empty($formErrors)) {

							$store['store_name']		= $storeName;
							$store['slogan']			= $slogan;
							$store['path']				= $path;
							$store['password']			= md5($password);
							$store['email_address']		= $emailAddress;
							$store['phone_number1'] 	= $phoneNumber1;
							$store['phone_number2'] 	= $phoneNumber2;
							$store['physical_address'] 	= $physicalAddress;
							$store['latitude']			= $latitude;
							$store['longitude']			= $longitude;
							$store['twitter']			= $twitter;
							$store['facebook']			= $facebook;
							$store['google']			= $google;
							
							$this->create_model->store($store);
							header("Location: ".base_url()."panel/login.html");
							exit;
						} else {
							// form errors found
							header("Location: ".base_url()."create.html");
						}
					}
					else
					{
						array_push(
							$formErrors, "<p>Logo image was not Uploaded</p>"
						);
					}
				}
				else
				{
					// passwords do not match
					if (!isset($_SESSION)) {
						session_start();
					}
					$_SESSION['errors'] = array(
						"<p>The passwords you entered do not match</p>"
					);
					session_write_close();
				}
			}
			else
			{
				// No data was submitted
				if (!isset($_SESSION)) {
					session_start();
				}
				$_SESSION['errors'] = array(
					"<p>Fill in all fields and try again</p>"
				);
				session_write_close();
			}
		}
	}

	function upload_image()
	{
		// Path that the logo image will be uploaded to
		$uploadPath = "./assets/images/store/";

		// Delete images in upload folder
		$images = glob($uploadPath.'*');
		foreach ($images as $key => $image) {
			if (is_file($image)) {
				unlink($image);
			}
		}

		// Ensure that the upload directory exists
		if ( ! file_exists($uploadPath) ) {

			if ( ! mkdir($uploadPath, 0777, true) ) {
				// Return an error if it should occur
				return array(
					"error" => 'create directory "assets/images/store" and retry'
				);
			}
		}
		// Load the CI upload library
		$config['upload_path'] 		= $uploadPath;
        $config['allowed_types']	= 'gif|jpg|png';
        $config['max_width'] 		= 0;
        $config['max_height'] 		= 0;
        $config['max_size'] 		= 0;
		$config['remove_spaces'] 	= FALSE;
        $config['encrypt_name'] 	= TRUE;
        $config['overwrite'] 		= TRUE;
        $this->load->library('upload', $config);

		if ( ! $this->upload->do_upload()) {
			// Return an error if it should occur
			return array('error' => $this->upload->display_errors());
		} else {
			$imageData = $this->upload->data();

			// Resize store logo to a smaller image
			$imageUrl = './assets/images/store/'.$imageData['file_name'];
			$path = str_replace("./", "", $imageUrl);

			$config['image_library'] 	= 'gd2';
			$config['source_image']		= $imageUrl;
			$config['file_name']		= $imageUrl;
			$config['create_thumb'] 	= FALSE;
			$config['maintain_ratio'] 	= TRUE;
			$config['width']	 		= 150;
			$config['height']			= 150;

			$this->load->library('image_lib');
			$this->image_lib->initialize($config);
			$this->image_lib->resize($config);

			return $path;
		}
	}
}