<?php
class Create_model extends CI_Model
{
	public function __construct()
	{
		parent::__construct();
		$this->load->database();
	}

	// creates a table "store" and adds User information to it
	// Database settings are in the application/config/database.php file
	public function store($store)
	{
		// Remove the current store table if it exists
		$this->db->query('DROP TABLE IF EXISTS `store`');

		// Build the store table
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `store` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `name` varchar(220) NOT NULL,
			  `logo` varchar(220) NOT NULL,
			  `slogan` varchar(220) NOT NULL,
			  `password` varchar(220) NOT NULL,
			  `phone1` varchar(220) NOT NULL,
			  `phone2` varchar(220) NOT NULL,
			  `email` varchar(220) NOT NULL,
			  `home` varchar(220) NOT NULL,
			  `latitude` varchar(220) NOT NULL,
			  `longitude` varchar(220) NOT NULL,
			  `google` varchar(220) NOT NULL,
			  `twitter` varchar(220) NOT NULL,
			  `facebook` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;"
		);

		// Add User's information to the store table
		$data = array(
			'name'		=> $store['store_name'],
			'logo'		=> $store['path'],
			'slogan'	=> $store['slogan'],
			'password'	=> $store['password'],
			'phone1' 	=> $store['phone_number1'],
			'phone2' 	=> $store['phone_number2'],
			'email'		=> $store['email_address'],
			'home' 		=> $store['physical_address'],
			'latitude' 	=> $store['latitude'],
			'longitude' => $store['longitude'],
			'google' 	=> $store['google'],
			'twitter' 	=> $store['twitter'],
			'facebook' 	=> $store['facebook']
		);
		$this->db->insert('store', $data);

		// create product tables
		$this->create_tables();
	}

	function create_tables()
	{
		// ----- build the product table -----------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product` (
			  `product_id` int(220) NOT NULL AUTO_INCREMENT,
			  `name` varchar(220) NOT NULL,
			  `description` longtext NOT NULL,
			  `slug` varchar(220) NOT NULL,
			  `price` varchar(220) NOT NULL,
			  `category` varchar(220) NOT NULL,
			  `sub_category` varchar(220) NOT NULL,
			  `type` varchar(220) NOT NULL,
			  `thumb` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_image table -----------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_image` (
			  `product_image_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_id` int(220) NOT NULL,
			  `image_url` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_image_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_color table -----------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_color` (
			  `product_color_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_id` int(220) NOT NULL,
			  `color` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_color_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_size table ------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_size` (
			  `product_size_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_id` int(220) NOT NULL,
			  `size` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_size_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_quantity table --------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_quantity` (
			  `product_quantity_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_id` int(220) NOT NULL,
			  `product_color` varchar(220) NOT NULL,
			  `product_size` varchar(220) NOT NULL,
			  `quantity` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_quantity_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_category table --------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_category` (
			  `product_category_id` int(220) NOT NULL AUTO_INCREMENT,
			  `category` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_category_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_sub_category table ----------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_sub_category` (
			  `product_sub_category_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_category_id` int(220) NOT NULL,
			  `sub_category` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_sub_category_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_type table ------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_type` (
			  `product_type_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_category_id` int(220) NOT NULL,
			  `product_sub_category_id` int(220) NOT NULL,
			  `type` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_type_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_description table -----------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_description` (
			  `product_description_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_id` int(220) NOT NULL,
			  PRIMARY KEY (`product_description_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_attribute table -------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute` (
			  `product_attribute_id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `attribute` varchar(220) NOT NULL,
			  PRIMARY KEY (`product_attribute_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_attribute_style table -------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_style` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_attribute_pattern table -----
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_pattern` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the product_attribute_neckline table ----
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_neckline` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);


		// ----- build the product_attribute_length table ------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_length` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);


		// ----- build the product_attribute_material table ----
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_material` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);


		// ----- build the product_attribute_season table ------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `product_attribute_season` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `product_type_id` int(220) NOT NULL,
			  `value` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the banner table ------------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `banner` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `banner` varchar(220) NOT NULL,
			  `category` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the slideshow table ------------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `slideshow` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `image` varchar(220) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the tasks table -------------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `tasks` (
			  `id` int(220) NOT NULL AUTO_INCREMENT,
			  `task` varchar(220) NOT NULL,
			  `date_added` date NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);

		// ----- build the message table ----------------------
		$query = $this->db->query(
			"CREATE TABLE IF NOT EXISTS `message` (
			  `message_id` int(220) NOT NULL AUTO_INCREMENT,
			  `type` varchar(220) NOT NULL,
			  `reference` varchar(220) NOT NULL,
			  `folder` varchar(220) NOT NULL,
			  `name` varchar(220) NOT NULL,
			  `title` varchar(220) NOT NULL,
			  `phone` varchar(220) NOT NULL,
			  `email` varchar(220) NOT NULL,
			  `location` varchar(220) NOT NULL,
			  `order_quantity` int(220) NOT NULL,
			  `target_price` varchar(220) NOT NULL,
			  `message` varchar(220) NOT NULL,
			  `date_added` date NOT NULL,
			  PRIMARY KEY (`message_id`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
		);
	}
}