<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Add extends MX_Controller
{
	
	public function __construct()
	{
		parent::__construct();
		$this->load->model('add_model');
		$this->load->library('session');
	}

	public function index()
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			// create tables
			$this->load->model('add_tables_model');
			
			if ($this->add_tables_model->create_tables() == TRUE) {
				$pageData['title']    = 'Dvee';
				$pageData['avatar']   = '<img src="'.base_url().$this->session->userdata('avatar').'" />';
				$pageData['username'] = $this->session->userdata('username');
				$pageData['categories'] = modules::run('records/get_input/categories');

				$images = glob('./assets/images/products/temp/*');
				foreach ($images as $key => $image)
				{
					if (is_file($image))
					{
						unlink($image);
					}
				}
				$this->load->view('forms/product_add_view', $pageData);
			} else {
				// failed to create tables
				if (!isset($_SESSION)) {
					session_start();
				}
				$_SESSION['add_item_success'] = 'failed to create tables';
				session_write_close();

				header("location: ".base_url()."panel/products/add.html");
			}
		}
	}

	public function product_details()
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$this->add_model->add_product_details();
			var_dump($_POST);

			if (!isset($_SESSION)) {
				session_start();
			}
			$_SESSION['add_item_success'] = true;
			session_write_close();

			header("location: ".base_url()."panel/products/add.html");
		}
	}

	public function temp_image()
	{
		$temp_path = "./assets/images/products/temp";

		// create the upload path if it doesn't exist
		if ( ! file_exists($temp_path)) {
			if ( ! mkdir($temp_path, 0777, true)) {
				echo ("ERROR: failed to create directory, Make sure you have read/write permission");
			}
		}
		
		// load and initialize the CI upload library
		$this->load->library('upload');
		$this->upload->initialize(array(
			"upload_path" 	=> $temp_path,
			"overwrite" 	=> TRUE,
			"encrypt_name" 	=> TRUE,
			"remove_spaces" => FALSE,
			"allowed_types" => "gif|jpg|png|jpeg|PNG",
			"max_size" 		=> 2000,
			"xss_clean" 	=> FALSE, // with PDF's YOU MUST TURN OFF xss_clean
		));

		if ($this->upload->do_multi_upload("files")) {
			$data['images'] = array();

			foreach ($this->upload->get_multi_upload_data() as $key => $image) {
				array_push($data['images'], $image['file_name']);
			}

			$this->load->view('input_widgets/image.php', $data);
		} else {
			// upload failed
			echo "failed";
		}
	}

	public function category($value)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$data['fragment'] 	= true;
			$data['categories'] = $this->add_model->category($value);

			$this->load->view('input_widgets/categories', $data);
		}
	}

	public function sub_category($value)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$array 		 = explode("_", $value);
			$category 	 = $array[0];
			$subCategory = $array[1];

			$data['fragment'] 		= true;
			$data['sub_categories'] = $this->add_model->sub_category($category, $subCategory);

			$this->load->view('category_widgets/sub_categories', $data);
		}
	}

	public function mainAttribute($value, $option = false)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$array 		  = explode("_", $value);
			$selectable   = $array[0];
			$typeID 	  = $array[1];
			$attribute 	  = $array[2];

			$data['fragment'] = true;

			$results 	  = $this->add_model->mainAttribute($typeID, $attribute);
			$attributes   = $results['attributes'];
			$typeID   	  = $results['typeID'];

			$data['attributes'] = $attributes;
			$data['typeID'] 	= $typeID;
			$data['selectable'] = $selectable;

			$this->load->view('category_widgets/attributes', $data);
		}
	}

	public function attribute_value($value)
	{
		if ($this->session->userdata('isLoggedIn') == false)
		{
			die('You are not logged in');
		} else {
			$array 		  = explode("_", $value);
			$typeID 	  = $array[0];
			$attribute 	  = $array[1];
			$string 	  = $array[2];
			$selectable   = $array[3];

			$data['attrVal'] 	= $attribute;
			$data['selectable'] = $selectable;
			$data['value']   	= $this->add_model->attribute_value($typeID, $attribute, $string);

			$this->load->view('category_widgets/attribute_value', $data);
		}
	}

	public function type($value)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$array 		  = explode("_", $value);
			$category 	  = $array[0];
			$subCategory  = $array[1];
			$type 		  = $array[2];
			$data['types'] = $this->add_model->type($category, $subCategory, $type);

			$data['fragment'] = true;
			
			$this->load->view('category_widgets/types', $data);
		}
	}

	public function task()
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			die('You are not logged in');
		} else {
			$data['tasks'] = $this->add_model->add_task();

			$this->load->view('input_widgets/task', $data);
		}
	}

	public function banners()
	{
		$this->load->model('banner_model');

		if (!isset($_SESSION)) {
			session_start();
		}
		if ($this->banner_model->upload() == TRUE) {
			$_SESSION['banner_success'] = true;
			session_write_close();
			header("location: ".base_url()."panel/products/banners.html");
		} else {
			$_SESSION['banner_success'] = false;
			session_write_close();
			header("location: ".base_url()."panel/products/banners.html");
		}
	}

	public function fragment_quantity()
	{
		// load a input quantity fragment
		$this->load->view('forms/fragment_quantity');
	}
}