<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Get_input extends MX_Controller
{

	public function __construct()
	{
		parent::__construct();
		$this->load->model('get_model');
		$this->load->library('session');
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| get product categories
	|--------------------------------------------------------------------------------------------------
	*/
	public function categories()
	{
		if( $this->session->userdata('isLoggedIn') == false )
		{
			die('You are not logged in');
		}
		else
		{

			return $this->get_model->category();
		}
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| get product sub-categories of a category
	|--------------------------------------------------------------------------------------------------
	*/
	public function sub_categories($category)
	{
		if( $this->session->userdata('isLoggedIn') == false )
		{
			die('You are not logged in');
		}
		else
		{
			$category  = str_replace("%20~%20", " & ", $category);

			$data['sub_categories'] = $this->get_model->subCategory($category);

			$this->load->view('input_widgets/sub_categories', $data);
		}
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| type | get product type of a sub-category
	|--------------------------------------------------------------------------------------------------
	*/
	public function type($classification)
	{
		if( $this->session->userdata('isLoggedIn') == false )
		{
			die('You are not logged in');
		}
		else
		{
			$category_array = explode("_", $classification);
			$category 		= str_replace("%20~%20", " & ", $category_array[0]);
			$sub_category 	= str_replace("%20~%20", " & ", $category_array[1]);

			$data['types'] = $this->get_model->type($category, $sub_category);

			$this->load->view('input_widgets/types', $data);
		}
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| quantityForm | get the quantity Form
	|--------------------------------------------------------------------------------------------------
	*/
	public function quantityForm()
	{

		if( $this->session->userdata('isLoggedIn') == false )
		{
			die('You are not logged in');
		}
		else
		{
			$color = explode(", ", $_POST['color']);
			$size  = explode(", ", $_POST['size']);
			
			$data['color'] = $color;
			$data['size']  = $size;
			$data['loop']  = count($color)-1 * count($size)-1;

			$this->load->view('addWidgetTemplates/quantity', $data);
		}
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| get product type attributes
	|--------------------------------------------------------------------------------------------------
	*/
	public function attr($ID = false, $option = false)
	{
		if( $this->session->userdata('isLoggedIn') == false )
		{
			die('You are not logged in');
		}
		else
		{

			$results 	  = $this->get_model->attributes($ID);
			$attributes   = $results['attributes'];
			$typeID   	  = $results['typeID'];

			$data['attributes'] = $attributes;
			$data['typeID'] 	= $typeID;
			$data['selectable'] = false;
			
			if ($option == "select_true")
			{
				$data['selectable'] = true;
			}

			$this->load->view('category_widgets/attributes', $data);
		}
	}

	public function adding_attr($ID = false)
	{
		echo modules::run('inventory/get/attr', $ID, "select_true");
	}
}
