<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Items extends MX_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->model('invetory_model');
		$this->load->helper(array('form', 'url'));
		$this->load->library('session');
	}

	public function display()
	{
		$pageData['title']    = 'Dvee';
		$pageData['avatar']   = '<img src="'.base_url().$this->session->userdata('avatar').'" />';
		$pageData['username'] = $this->session->userdata('username');

		// Fetch products from the database
		$data = $this->invetory_model->get_products();

		if ($data == false) {
			$pageData['products'] 		= FALSE;
			$pageData['product_count']	= 0;
		} else {
			$pageData["products"]		= $data;
			$pageData['product_count']	= count($data);
		}
		
		$this->load->view('products_view', $pageData);
	}

	public function add($value = FALSE)
	{
		// create tables
		$this->load->model('add_tables_model');
		
		if ($this->add_tables_model->create_tables() == TRUE) {
			$pageData['categories'] = modules::run('records/get_input/categories');

			$images = glob('./assets/images/products/temp/*');
			foreach ($images as $key => $image) {
				if (is_file($image)) {
					unlink($image);
				}
			}
			$pageData['title'] 		= 'Dvee';
			$pageData['avatar'] 	= '<img src="'.base_url().$this->session->userdata('avatar').'" />';
			$pageData['username'] 	= $this->session->userdata('username');
			$pageData['categories'] = $this->panel_model->get_product_categories();
			$this->load->view('forms/product_add_view', $pageData);
		} else {
			$pageData['error_title'] 	= 'DATABASE ERROR';
			$pageData['error_message'] 	= 'failed to create product databases';
			$pageData['error_remedy'] 	= 'Ensure that you have database write permission';
			echo modules::run("template/serve/admin_error", $pageData);
		}
	}

	public function edit($ID = FALSE)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products-edit-".$ID);
		} else {
			if ($ID == FALSE) {
				die("ERROR: Product not defined");
			} else {
				$product_details = modules::run('productDB/get/details', $ID, "editable");
				$data['title'] 			= 'Dvee';
				$data['avatar'] 		= '<img src="'.base_url().$this->session->userdata('avatar').'" />';
				$data['username'] 		= $this->session->userdata('username');
				$data['product'] 		= $product_details['product'];
				$data['categories'] 	= $this->invetory_model->get_product_categories();
				$data['types'] 			= $this->invetory_model->get_product_types();
				$data['sub_categories'] = $this->invetory_model->get_product_sub_categories();
				$data['thumbnail'] 		= str_replace("thumb/", "", $data['product']['thumb']);

				$cat 	= $data['product']['category'];
				$subCat = $data['product']['sub_category'];
				$type 	= $data['product']['type'];

				$results = $this->invetory_model->attributes($cat, $subCat, $type);
				$data['attributes'] = $results['attributes'];
				$data['typeID'] 	= $results['typeID'];
				
				$this->load->view('forms/product_edit_view', $data);
				
			}
		}
	}
}
