<?php

class Add_model extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	/*
	|--------------------------------------------------------------------------
	| Add product details to the appropriate tables
	|--------------------------------------------------------------------------
	*/
	public function add_product_details()
	{
		// prepare the post data
		$product['name'] 		 = $this->input->post('name');
		$product['description']  = $this->input->post('description');
		$product['price'] 		 = $this->input->post('price');
		$product['category'] 	 = $this->input->post('category');
		$product['sub_category'] = $this->input->post('sub_category');
		$product['type'] 		 = $this->input->post('type');
		$product['slug'] 		 = str_replace(" ", "_", $product['name']);
		$item['colors'] 		 = $this->input->post('color');
		$item['sizes'] 		 	 = $this->input->post('size');
		$item['quantity'] 	 	 = $this->input->post('quantity');
		$item['attributes']   	 = $this->input->post("attribute");

		$similar = $this->db->get_where('product', $product)->result();

		if (count($similar) > 0) {
			// a similar product exists
			header("location: ".base_url()."panel/products.html");
		} else {
			// populate the product table
			$this->db->insert('product', $product);

			// get product_id to insert into other
			$queryID 	= $this->db->get_where('product', $product);
			$resultID 	= $queryID->result();
			$product_id	= $resultID[0]->product_id;

			// populate the product_color table
			foreach (array_unique($item['colors']) as $key => $color) {
				
				$productColor['product_id'] = $product_id;
				$productColor['color'] 	 	= $color;

				$this->db->insert('product_color', $productColor);
			}

			// populate the product_size table
			foreach (array_unique($item['sizes']) as $key => $size) {

				$productSize['product_id'] = $product_id;
				$productSize['size'] 	   = $size;

				$this->db->insert('product_size', $productSize);
			}

			// populate the product_quantity table
			foreach ($item['quantity'] as $key => $quantity) {

				$productQuantity['product_id'] 	  = $product_id;
				$productQuantity['product_color'] = $item['colors'][$key];
				$productQuantity['product_size']  = $item['sizes'][$key];
				$productQuantity['quantity']	  = $quantity;

				$this->db->insert('product_quantity', $productQuantity);
			}
		}


		// Add product attributes
		if (is_array($item['attributes'])) {

			$id = array('product_id' => $product_id);

			// populate the product_description table
			$this->db->insert('product_description', $id);

			// get attributes of this product type
			// get product category ID
			$category_array = array('category' => $product['category']);
			$category_query = $this->db->get_where('product_category', $category_array)->result();
			$categoryID 	= $category_query[0]->product_category_id;

			// get product sub-category ID
			$sub_category_array = array(
				'product_category_id' 	=> $categoryID,
				'sub_category'			=> $product['sub_category']
			);
			$sub_category_query = $this->db->get_where('product_sub_category', $sub_category_array)->result();
			$sub_categoryID 	= $sub_category_query[0]->product_sub_category_id;

			// get product type ID
			$type_array = array(
				'product_category_id' 		=> $categoryID,
				'product_sub_category_id' 	=> $sub_categoryID,
				'type'						=> $product['type']
			);
			$type_query = $this->db->get_where('product_type', $type_array)->result();
			$typeID 	= $type_query[0]->product_type_id;

			// get product attributes of a specific type
						  $this->db->select('attribute');
			$attributes = $this->db->get_where('product_attribute', array('product_type_id' => $typeID))->result();
			
			foreach ($attributes as $key => $field) {
				$field = str_replace(" ", "_", $field->attribute);
				$field = str_replace("-", "_", $field);
				if (!$this->db->field_exists($field, 'product_description')) {
					$query  = $this->db->query(
						"ALTER TABLE product_description ADD ".$field." VARCHAR(220);"
					);
				}
			}
			foreach ($item['attributes'] as $key => $array) {

				$data  = explode("_", $array);
				$field = str_replace("%20", "_", $data[0]);
				$value = str_replace("%20", "_", $data[1]);
				$field = str_replace(" ", "_", $field);
				$field = str_replace("-", "_", $field);
				
				$this->db->where('product_id', $product_id);
				$this->db->update('product_description', array($field => $value));
			}
		}

		// get uploaded images from the temp folder
		$images = glob('./assets/images/products/temp/*');

		for ($i=0; $i < count($images); $i++) {

			$image_folder = str_replace("/temp", "", $images[$i]);

			copy($images[$i], $image_folder);

			$image_url 	= $image_folder;
			$path 		= str_replace("./", "", $image_url);

			// load the CI image library with these configurations
			$config['image_library'] 	= 'gd2';
			$config['source_image']		= $image_url;
			$config['file_name']		= $image_url;
			$config['create_thumb'] 	= FALSE;
			$config['maintain_ratio'] 	= FALSE;
			$config['width']	 		= 300;
			$config['height']			= 300;

			$this->load->library('image_lib');
			$this->image_lib->initialize($config);
			$this->image_lib->resize();

			// Insert the images' paths into the product_image table
			$data = array(
				'product_id' => $product_id,
				'image_url'  => $path
			);
			$this->db->insert('product_image', $data);
		}

		// Get the path of the first image in the images array
		$image_url 	 = $images[0];
		$destination = str_replace("temp", "thumb", $image_url);
		
		// Copy the first image to thumb folder
		copy($image_url, $destination);

		// load the CI image library with these configurations
		// Then resize the thumbnail to smaller dimensions
		$config['image_library'] 	= 'gd2';
		$config['source_image']		= $destination;
		$config['file_name']		= $destination;
		$config['create_thumb'] 	= FALSE;
		$config['maintain_ratio'] 	= FALSE;
		$config['width']	 		= 150;
		$config['height']			= 150;

		$this->load->library('image_lib');
		$this->image_lib->initialize($config);
		$this->image_lib->resize();

		// Update the image thumbnail path in the product table
		$path = str_replace("./", "", $destination);
		$this->db->where('product_id', $product_id);
		$this->db->update('product', array('thumb' => $path));

		// Delete files from the temp folder
		$images = glob('./assets/images/products/temp/*');
		foreach ($images as $key => $image) {
			if (is_file($image)) {
				unlink($image);
			}
		}
	}



	/*
	|--------------------------------------------------------------------------
	| Add a product category
	|--------------------------------------------------------------------------
	*/
	public function category($value)
	{
		// sanitize the values
		$value = strtolower($value);
		$value = str_replace("%20", " ", $value);

		$this->db->insert('product_category', array('category' => $value));

		return $this->db->get_where('product_category', array('category' => $value))->result();
	}

	/*
	|--------------------------------------------------------------------------
	| Add a product subCategory
	|--------------------------------------------------------------------------
	*/
	public function sub_category($category, $subCategory)
	{
		// sanitize the values
		$category 	 = strtolower($category);
		$subCategory = strtolower($subCategory);
		$category 	 = str_replace("%20", " ", $category);
		$subCategory = str_replace("%20", " ", $subCategory);

		$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
		$queryCategoryResult = $queryCategory->result();
		$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;
		
		$subCategoryArray = array(
			'product_category_id' => $CategoryID,
			'sub_category' 		  => $subCategory
		);
		$this->db->insert('product_sub_category', $subCategoryArray);
		
		return $this->db->get_where('product_sub_category', $subCategoryArray)->result();
	}

	/*
	|--------------------------------------------------------------------------
	| Add a product subCategory
	|--------------------------------------------------------------------------
	*/
	public function type($category, $subCategory, $type)
	{
		// sanitize the values
		$category 	 = strtolower($category);
		$subCategory = strtolower($subCategory);
		$type 		 = strtolower($type);
		$category 	 = str_replace("%20", " ", $category);
		$subCategory = str_replace("%20", " ", $subCategory);
		$type 		 = str_replace("%20", " ", $type);

		$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
		$queryCategoryResult = $queryCategory->result();
		$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;

		$subCategoryArray = array(
			'product_category_id' => $CategoryID,
			'sub_category'        => $subCategory
		);

		$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
		$querysubCategoryResult  = $querysubCategory->result();
		$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
		
		$productTypeArray = array(
			'product_category_id' 	  => $CategoryID,
			'product_sub_category_id' => $subCategoryID,
			'type' 					  => $type
			);

		$this->db->insert('product_type', $productTypeArray);

		//get the just added type value
		$querytype   = $this->db->get_where('product_type', $productTypeArray);
		$typeResult  = $querytype->result();
		$addedtype	 = $typeResult[0]->type;

		return $addedtype;
	}


	/*
	|--------------------------------------------------------------------------
	| Add a product attribute
	|--------------------------------------------------------------------------
	*/
	public function mainAttribute($typeID, $attribute)
	{
		// sanitize the values
		$typeID 	= strtolower($typeID);
		$attribute  = strtolower($attribute);
		$typeID 	= str_replace("%20", " ", $typeID);
		$attribute  = str_replace("%20", "_", $attribute);
		$value  	= str_replace("_", " ", $attribute);

		$attributes = array();

		$attrArray  = array(
		   'product_type_id' => $typeID,
		   'attribute' 		 => $value
		);

		// ensure that the specific attribute table does not exist
		if ($this->db->table_exists('product_attribute_'.$attribute))
		{
			// attribute table exists

			$attribute_results = $this->db->get_where('product_attribute', $attrArray)->result();

			if (empty($attribute_results)) {
				$this->db->insert('product_attribute', $attrArray);
			}
		}
		else
		{
			// create attribute table
			$query = $this->db->query(
				"CREATE TABLE IF NOT EXISTS `product_attribute_".$attribute."` (
				  `id` int(220) NOT NULL AUTO_INCREMENT,
				  `product_type_id` int(220) NOT NULL,
				  `value` varchar(220) NOT NULL,
				  PRIMARY KEY (`id`)
				) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;"
			);
			$this->db->insert('product_attribute', $attrArray);
		}

		$queryAttributes  = $this->db->get_where('product_attribute', $attrArray);
		$attributeTitles  = $queryAttributes->result();


		foreach ($attributeTitles as $attributeTitlesKey => $attributeTitlesValue)
		{
			$attribute = str_replace(" ", "_", $attributeTitlesValue->attribute);
			$attribute = str_replace("-", "_", $attribute);

			$queryAttributeValues  = $this->db->get_where(
									'product_attribute_'.$attribute,
									 array('product_type_id' => $typeID)
									);
			$attributeValuesTitles = $queryAttributeValues->result();

			array_push(
				$attributes,
				array('attribute_title' => $attributeTitlesValue->attribute)
			);
			
			foreach ($attributeValuesTitles as $attributeValuesKey => $attributeValue)
			{
				array_push(
					$attributes[$attributeTitlesKey],
					array('attribute_value' => $attributeValue->value)
				);
			}
		}
		
		// return $attributes;
		return array('attributes' => $attributes, 'typeID' => $typeID);
	}

	/*
	|--------------------------------------------------------------------------
	| Add a product attribute value
	|--------------------------------------------------------------------------
	*/
	public function attribute_value($typeID, $attribute, $value)
	{

		// sanitize the values
		$typeID 	= strtolower($typeID);
		$attribute 	= strtolower($attribute);
		$value 		= strtolower($value);
		$typeID 	= str_replace("%20", " ", $typeID);
		$attribute 	= str_replace("%20", "_", $attribute);
		$attribute 	= str_replace("-", "_", $attribute);
		$value 		= str_replace("%20", " ", $value);

		// add attribute value to the right table
		if ($this->db->table_exists('product_attribute_'.$attribute))
		{
			$attrArray = array(
			   'product_type_id' => $typeID,
			   'value' 			 => $value
			);

			$this->db->insert('product_attribute_'.$attribute, $attrArray);

			$queryAttrVal 	= $this->db->get_where('product_attribute_'.$attribute, $attrArray);
			$AttrValResult  = $queryAttrVal->result();
			$addedAttrVal	= $AttrValResult[0]->value;

			return $addedAttrVal;
		}
		else{
			echo "no existant";
		}
	}

	/*
	|--------------------------------------------------------------------------
	| Add tasks
	|--------------------------------------------------------------------------
	*/
	public function add_task()
	{
		$insert_array['task'] 		= $this->input->get("task");
									  date_default_timezone_set("Africa/Nairobi");
		$insert_array['date_added'] = date("Ymd");

		$this->db->insert('tasks', $insert_array);

		$data = $this->db->get_where('tasks', $insert_array)->result();
		
		// check if the query yeilds results
		if ( ! empty($data) )
		{
			$tasks = array();

			// define curent date
							date_default_timezone_set("Africa/Nairobi");
			$current_date = date("Ymd");
			
			// calculate duration
			foreach ($data as $key => $value)
			{
				$date_added = str_replace("-", "", $value->date_added);
				$duration 	= $current_date - $date_added;

				array_push($tasks, array(
					'id' 		=> $value->id,
					'task' 		=> $value->task,
					'duration' 	=> $duration
				));
				
			}
			return $tasks;
		}else
		{
			// no results found in the database
			return;
		}

	}
}