<?php
class Add_tables_model extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| Create tables for the product
	|--------------------------------------------------------------------------------------------------
	*/
	public function create_tables()
	{
		// populate the product_category table
		if ($this->db->table_exists('product_category') && $this->db->count_all('product_category') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_category` (`product_category_id`, `category`) VALUES
				(1, 'women'),
				(2, 'men'),
				(3, 'shoes'),
				(4, 'bags'),
				(5, 'jewelry');"
			);
		}

		// populate the product_sub_category table
		if ($this->db->table_exists('product_sub_category') && $this->db->count_all('product_sub_category') == 0)
		{
			$query  = $this->db->query(
				"INSERT INTO `product_sub_category` (`product_sub_category_id`, `product_category_id`, `sub_category`) VALUES
				(1, 1, 'dresses'),
				(2, 1, 'tops'),
				(3, 1, 'bottoms'),
				(4, 1, 'outerwear');"
			);
		}

		// populate the product_type table
		if ($this->db->table_exists('product_type') && $this->db->count_all('product_type') == 0  )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_type` (`product_type_id`, `product_category_id`, `product_sub_category_id`, `type`) VALUES
				(1, 1, 1, 'bandage'),
				(2, 1, 1, 'maxi'),
				(3, 1, 1, 'lace'),
				(4, 1, 1, 'cute'),
				(5, 1, 1, 'chiffon'),
				(8, 1, 1, 'mini'),
				(12, 1, 1, 'summer'),
				(13, 1, 1, 'casual'),
				(14, 1, 1, 'vintage'),
				(15, 1, 1, 'bodycon'),
				(16, 1, 3, 'pants'),
				(17, 1, 3, 'shorts'),
				(18, 1, 3, 'leggings'),
				(19, 1, 3, 'skirts'),
				(20, 1, 3, 'denim & jeans'),
				(21, 1, 3, 'hoisery'),
				(22, 1, 3, 'jumpsuits'),
				(25, 1, 2, 'tees & t-shirts'),
				(26, 1, 2, 'blouses'),
				(27, 1, 2, 'vests'),
				(28, 1, 2, 'waistcoats'),
				(29, 1, 2, 'capes'),
				(30, 1, 4, 'jackets & coats'),
				(31, 1, 4, 'blazers'),
				(32, 1, 4, 'sweatshirts & hoddies'),
				(33, 1, 4, 'sweaters & cardigans'),
				(34, 1, 4, 'activewear'),
				(35, 1, 5, 'socks & hoisery'),
				(36, 1, 5, 'scarves'),
				(37, 1, 5, 'hats'),
				(38, 1, 5, 'belts'),
				(39, 1, 5, 'gloves'),
				(40, 1, 5, 'ear muffs');"
			);
		}

		// populate the product_attribute table
		if ($this->db->table_exists('product_attribute') && $this->db->count_all('product_attribute') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute` (`product_type_id`, `attribute`) VALUES
				(1, 'style'),
				(1, 'pattern'),
				(1, 'neckline'),
				(1, 'length'),
				(1, 'material'),
				(1, 'season');"
			);
		}

		//  populate the product_attribute_style table
		if ($this->db->table_exists('product_attribute_style') && $this->db->count_all('product_attribute_style') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_style` (`product_type_id` ,`value`) VALUES
				(1, 'fashion'),
				(1, 'formal'),
				(1, 'evening'),
				(1, 'casual'),
				(1, 'cute'),
				(1, 'ethnic'),
				(1, 'vintage');"
			);
		}

		// populate the product_attribute_pattern table
		if ($this->db->table_exists('product_attribute_pattern') && $this->db->count_all('product_attribute_pattern') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_pattern` (`product_type_id` ,`value`) VALUES
				(1, 'animal print'),
				(1, 'floral'),
				(1, 'striped'),
				(1, 'solid'),
				(1, 'polkadot'),
				(1, 'dotted'),
				(1, 'checkered'),
				(1, 'goemetry');"
			);
		}

		// populate the product_attribute_neckline table
		if ($this->db->table_exists('product_attribute_neckline') && $this->db->count_all('product_attribute_neckline') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_neckline` (`product_type_id` ,`value`) VALUES
				(1, 'round'),
				(1, 'v-neck'),
				(1, 'spaghetti strap'),
				(1, 'halter'),
				(1, 'square'),
				(1, 'slash'),
				(1, 'turn-down');"
			);
		}

		// populate the product_attribute_length table
		if ($this->db->table_exists('product_attribute_length') && $this->db->count_all('product_attribute_length') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_length` (`product_type_id` ,`value`) VALUES
				(1, 'mid-calf'),
				(1, 'mini'),
				(1, 'knee-length'),
				(1, 'ankle-legth'),
				(1, 'floor-length');"
			);
		}

		// populate the product_attribute_material table
		if ($this->db->table_exists('product_attribute_material') && $this->db->count_all('product_attribute_material') == 0 )
		{
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_material` (`product_type_id` ,`value`) VALUES
				(1, 'cotton'),
				(1, 'lace'),
				(1, 'Denim'),
				(1, 'polyester'),
				(1, 'chiffon'),
				(1, 'leather'),
				(1, 'silk'),
				(1, 'nylon'),
				(1, 'spandex'),
				(1, 'canvas');"
			);
		}

		// populate the product_attribute_season table
		if ($this->db->table_exists('product_attribute_season') && $this->db->count_all('product_attribute_season') == 0 ) {
			$query  = $this->db->query(
				"INSERT INTO `product_attribute_season` (`product_type_id` ,`value`) VALUES
				(1, 'summer'),
				(1, 'spring'),
				(1, 'winter');"
			);
		}


		return TRUE;
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product categories
	|--------------------------------------------------------------------------
	|
	| For the template to consume
	|
	*/
	public function getCategory() {

		$queryCategories = $this->db->get('product_category');
		$categories 	 = $queryCategories->result();

		return $categories;
	}
}