<?php

class Banner_model extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	/*
	|---------------------------------------------------------------------------------------------
	| fetch all banners from the database
	|---------------------------------------------------------------------------------------------
	*/
	public function getBanners()
	{
		$result = $this->db->get('banner')->result();

		if (!empty($result))
		{
			return $result;
		}
		else
		{
			return false;
		}
	}

	/*
	|----------------------------------------------------------------------------------
	| upload banners
	|----------------------------------------------------------------------------------
	*/
	public function upload()
	{
		// load and initialize the CI upload library
		$this->load->library('upload');

		// upload images to the banners folder
		$this->upload->initialize(array(
			"upload_path" 	=> "./assets/images/banner/",
			"overwrite" 	=> TRUE,
			"encrypt_name" 	=> TRUE,
			"remove_spaces" => FALSE,
			"allowed_types" => "gif|jpg|png",
			"max_size" 		=> 2000,
			"xss_clean" 	=> FALSE,
		));

		// Path that the images will be uploaded to
		$upload_path = "./assets/images/banner/";

		// Ensure that the upload path is vaild
		if ( ! file_exists($upload_path) )
		{
			// Try to create the upload path directory
			if ( ! mkdir($upload_path, 0777, true) )
			{
				// Return an error if it should occur
				echo ("ERROR: failed to create directory <b>assets/images/banner/</b>");
				echo (", Make sure you have read/write permission");
			}
		}

		// ensure that the images are uploaded
		if ($this->upload->do_multi_upload("files"))
		{
			$images = $this->upload->get_multi_upload_data();

			for ($i=0; $i < count($images); $i++)
			{
				$image_url 	= $upload_path.$images[$i]['file_name'];
				$path 		= str_replace("./", "", $image_url);

				// load the CI image library with these configurations
				// Resize the uploaded images
				$config['image_library'] 	= 'gd2';
				$config['source_image']		= $image_url;
				$config['file_name']		= $image_url;
				$config['create_thumb'] 	= FALSE;
				$config['maintain_ratio'] 	= FALSE;
				$config['width']	 		= 400;
				$config['height']			= 200;
				
				$this->load->library('image_lib');
				$this->image_lib->initialize($config);
				$this->image_lib->resize();

				// Insert the images' paths into the banner table
				$this->db->insert('banner', array('banner'  => $path));
			}
			return TRUE;
		}else
		{	
			return FALSE;
		}
	}

	/*
	|-----------------------------------------------------------------------------
	| delete | delete banners
	|-----------------------------------------------------------------------------
	*/
	public function delete($ID)
	{
		// get the banner url
		$result = $this->db->get_where("banner", array('id' => $ID))->result();

		$image  = $result[0];

		if (!empty($image))
		{
			unlink("./".$image->banner);
		}

		// delete the banner
		$this->db->delete("banner", array('id' => $ID));
	}
}

?>