<?php
class Delete_model extends CI_Model
{

	protected $database;

	public function __construct()
	{
		$this->load->database();
	}

	/*
	|--------------------------------------------------------------------------
	| Delete a product category
	|--------------------------------------------------------------------------
	*/
	public function category($value)
	{
		$value = strtolower($value);
		$value = str_replace("%20", " ", $value);

		
		$queryCategory 	= $this->db->get_where('product_category', array('category' => $value))->result();
		$CategoryID 	= $queryCategory[0]->product_category_id;
		
		$this->db->delete('product_category', array('category' => $value));
		$this->db->delete('product_sub_category', array('product_category_id' => $CategoryID));
		$this->db->delete('product_type', array('product_category_id' => $CategoryID));

		return TRUE;
	}

	/*
	|--------------------------------------------------------------------------
	| Delete a product subCategory
	|--------------------------------------------------------------------------
	*/
	public function subCategory($category, $subCategory)
	{
		$category 	 = strtolower($category);
		$subCategory = strtolower($subCategory);
		$category 	 = str_replace("%20", " ", $category);
		$subCategory = str_replace("%20", " ", $subCategory);

		$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
		$queryCategoryResult = $queryCategory->result();
		$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;
		
		$subCategoryArray	 = array('product_category_id' => $CategoryID, 'sub_category' => $subCategory);
		$querySubCategory    = $this->db->get_where('product_sub_category', $subCategoryArray)->result();
		$subCategoryID	 	 = $querySubCategory[0]->product_sub_category_id;

		$this->db->delete('product_sub_category', array('product_sub_category_id' => $subCategoryID));
		$this->db->delete('product_type', array('product_sub_category_id' => $subCategoryID));

		return TRUE;
	}

	/*
	|--------------------------------------------------------------------------
	| Delete a product subCategory
	|--------------------------------------------------------------------------
	*/
	public function type($category, $subCategory, $type)
	{

		$category 	 = strtolower($category);
		$subCategory = strtolower($subCategory);
		$type 		 = strtolower($type);
		$category 	 = str_replace("%20", " ", $category);
		$subCategory = str_replace("%20", " ", $subCategory);
		$type 		 = str_replace("%20", " ", $type);

		$queryCategory  = $this->db->get_where('product_category', array('category' => $category))->result();
		$categoryID		= $queryCategory[0]->product_category_id;

		$subCategoryArray 	= array('product_category_id' => $categoryID, 'sub_category' => $subCategory);
		$querysubCategory   = $this->db->get_where('product_sub_category', $subCategoryArray)->result();
		$subCategoryID		= $querysubCategory[0]->product_sub_category_id;
		
		$typeArray 	= array('product_category_id' => $categoryID, 'product_sub_category_id' => $subCategoryID, 'type' => $type);
		$querytype  = $this->db->get_where('product_type', $typeArray)->result();
		$typeID	 	= $querytype[0]->product_type_id;

		$this->db->delete('product_type', $typeArray);

		return TRUE;
	}


	/*
	|--------------------------------------------------------------------------
	| Delete a product attribute value
	|--------------------------------------------------------------------------
	*/
	public function attribute_value($typeID, $attribute, $value)
	{

		$typeID 	 = strtolower($typeID);
		$attribute 	 = strtolower($attribute);
		$value 		 = strtolower($value);
		$typeID 	 = str_replace("%20", " ", $typeID);
		$attribute 	 = str_replace("%20", " ", $attribute);
		$value 		 = str_replace("%20", " ", $value);

		$data = array(
		   'product_type_id' => $typeID,
		   'value' 			 => $value
		);

		$this->db->delete('product_attribute_'.$attribute, $data);

		return TRUE;
	}

	/*
	|--------------------------------------------------------------------------
	| Delete a product attribute
	|--------------------------------------------------------------------------
	*/
	public function mainAttribute($typeID, $attribute)
	{

		$typeID 	 = strtolower($typeID);
		$attribute 	 = strtolower($attribute);
		$typeID 	 = str_replace("%20", " ", $typeID);
		$attribute 	 = str_replace("%20", " ", $attribute);
		$attr_field  = str_replace("-", "_", $attribute);
		$attr_field  = str_replace(" ", "_", $attr_field);

		$attributes = $this->db->get_where('product_attribute', array('attribute' => $attribute))->result();

		// delete attribute table if there is no record of it in product_attribute table
		if (empty($attributes))
		{
			$this->db->query('DROP table '.'product_attribute_'.$attr_field);

			return TRUE;
		}
		else
		{
			// delete attribute table if no other types share this attribute
			if (count($attributes) == 1)
			{
				// delete attribute from product attribute table
				$data = array(
				   'product_type_id' => $typeID,
				   'attribute' 		 => $attribute
				);
				$this->db->delete('product_attribute', $data);

				// delete attribute table
				$this->db->query('DROP table '.'product_attribute_'.$attr_field);
			}
			else
			{
				// delete an attribute for a specific type  in the attribute table
				$data = array(
				   'product_type_id' => $typeID,
				);
				$this->db->delete('product_attribute_'.$attr_field, $data);
				// delete attribute from product attribute table
				$data = array(
				   'product_type_id' => $typeID,
				   'attribute' 		=> $attribute
				);
				$this->db->delete('product_attribute', $data);
			}
		}

		return TRUE;
	}

	/*
	|--------------------------------------------------------------------------------------------------
	| delete a product entry
	|--------------------------------------------------------------------------------------------------
	*/
	public function deleteProduct($ID)
	{
		$queryArray = array('product_id' => $ID);

		// Delete thumbnail image
		$querythumb  = $this->db->get_where('product', $queryArray);
		$thumbResult = $querythumb->result();
		foreach ($thumbResult as $key => $value)
		{
			$image ="./".$value->thumb;
			unlink($image);
		}
		// Delete all images
		$queryImages = $this->db->get_where('product_image', $queryArray);
		$ImageResult = $queryImages->result_array();
		foreach ($ImageResult as $key => $value)
		{
			$image ="./".$value['image_url'];
			unlink($image);
		}
		// delete the rest of the data in the database
		$query = $this->db->delete('product', 			$queryArray);
		$query = $this->db->delete('product_size', 		$queryArray);
		$query = $this->db->delete('product_color', 		$queryArray);
		$query = $this->db->delete('product_quantity', 	$queryArray);
		$query = $this->db->delete('product_description', $queryArray);
		$query = $this->db->delete('product_image', 		$queryArray);
	}

	/*
	|---------------------------------------------------------------------------------------------
	| delete product image
	|---------------------------------------------------------------------------------------------
	*/
	public function delete_product_image($ID)
	{
		// get the banner url
		$query_array  = array('product_image_id' => $ID);
		$query_image  = $this->db->get_where("product_image", $query_array)->result();
		$image_url 	  = $query_image[0]->image_url;

		// delete the database record
		$this->db->delete("product_image", $query_array);

		// delete the image
		unlink("./".$image_url);
	}

	/*
	|---------------------------------------------------------------------------------------------
	| delete task
	|---------------------------------------------------------------------------------------------
	*/
	public function delete_task($ID)
	{
		$this->db->delete("tasks", array('id' => $ID));
	}
}