<?php
class Get_model extends CI_Model
{

	protected $database;

	public function __construct()
	{
		$this->load->database();
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product categories
	|--------------------------------------------------------------------------
	*/
	public function category()
	{

		$queryCategories = $this->db->get('product_category');
		$categories 	 = $queryCategories->result();

		return $categories;
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product sub-categories
	|--------------------------------------------------------------------------
	*/
	public function subCategory($category)
	{
		$category 		 = str_replace("%20", " ", $category);

		$query_CategoryID 	 = $this->db->get_where('product_category', array('category' => $category ))->result();
		$categoryID		  	 = $query_CategoryID[0]->product_category_id;
		$query_subCategories = $this->db->get_where('product_sub_category', array('product_category_id' => $categoryID ));
		$subCategories		 = $query_subCategories->result();

		return $subCategories;
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product type
	|--------------------------------------------------------------------------
	*/
	public function type($category, $sub_category)
	{
		$category 		= str_replace("%20", " ", $category);
		$sub_category 	= str_replace("%20", " ", $sub_category);


		$query_category = $this->db->get_where('product_sub_category', array('sub_category' => $sub_category ))->result();
		$categoryID		= $query_category[0]->product_category_id;

		$query_subCategory  = $this->db->get_where('product_sub_category', array('sub_category' => $sub_category ))->result();
		$subCategoryID 		= $query_subCategory[0]->product_sub_category_id;

		$typesArray  = array('product_category_id' => $categoryID, 'product_sub_category_id' => $subCategoryID );
		$types		 = $this->db->get_where('product_type', $typesArray)->result();

		return $types;
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product type
	|--------------------------------------------------------------------------
	*/
	public function typeID($category, $sub_category, $type)
	{
		$category 		= str_replace("%20", " ", $category);
		$sub_category 	= str_replace("%20", " ", $sub_category);
		$type 			= str_replace("%20", " ", $type);



		$query_category = $this->db->get_where('product_sub_category', array('sub_category' => $sub_category ))->result();
		$categoryID		= $query_category[0]->product_category_id;

		$query_subCategory  = $this->db->get_where('product_sub_category', array('sub_category' => $sub_category ))->result();
		$subCategoryID 		= $query_subCategory[0]->product_sub_category_id;

		$typesArray  = array('product_category_id' => $categoryID, 'product_sub_category_id' => $subCategoryID, 'type' => $type);
		$type		 = $this->db->get_where('product_type', $typesArray)->result();
		$typeID		 = $type[0]->product_type_id;

		return $typeID;
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product attributes
	|--------------------------------------------------------------------------
	*/
	public function attributes($slug)
	{
		$attributes  = array();

		$slug_value  = explode("_", $slug);


		if (isset($slug_value[2]))
		{
			$category 		= str_replace("%20", " ", $slug_value[0]);
			$subCategory 	= str_replace("%20", " ", $slug_value[1]);
			$type 			= str_replace("%20", " ", $slug_value[2]);

			$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
			$queryCategoryResult = $queryCategory->result();
			$categoryID		 	 = $queryCategoryResult[0]->product_category_id;
			$subCategoryArray 		 = array(
				'product_category_id'=> $categoryID,
				'sub_category' 		 => $subCategory
			);
			$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
			$querysubCategoryResult  = $querysubCategory->result();
			$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
			
			$typeArray 	 = array(
				'product_category_id' 	  => $categoryID,
				'product_sub_category_id' => $subCategoryID, 'type' => $type
			);	
			$querytype   = $this->db->get_where('product_type', $typeArray);
			$typeResult  = $querytype->result();
			$typeID	 	 = $typeResult[0]->product_type_id;
		}
		else
		{
			$productInfo = $this->db->get_where('product', array('product_id' => $slug))->result();
			$category 	 = $productInfo[0]->category;
			$subCategory = $productInfo[0]->sub_category;
			$type 		 = $productInfo[0]->type;

			$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
			$queryCategoryResult = $queryCategory->result();
			$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;

			$subCategoryArray 		 = array(
				'product_category_id'=> $CategoryID,
				'sub_category' 		 => $subCategory
			);
			$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
			$querysubCategoryResult  = $querysubCategory->result();
			$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
			
			$typeArray 	 = array(
				'product_category_id' 	  => $CategoryID,
				'product_sub_category_id' => $subCategoryID, 'type' => $type
			);	
			$querytype   = $this->db->get_where('product_type', $typeArray);
			$typeResult  = $querytype->result();
			$typeID	 	 = $typeResult[0]->product_type_id;
		}




		$queryAttributes  = $this->db->get_where('product_attribute', array('product_type_id' => $typeID));
		$attributeTitles  = $queryAttributes->result();

		foreach ($attributeTitles as $attributeTitlesKey => $attributeTitlesValue)
		{
			$attribute = str_replace(" ", "_", $attributeTitlesValue->attribute);
			$attribute = str_replace("-", "_", $attribute);

			$queryAttributeValues  = $this->db->get_where(
									'product_attribute_'.$attribute,
									 array('product_type_id' => $typeID)
									);
			$attributeValuesTitles = $queryAttributeValues->result();

			array_push(
				$attributes,
				array('attribute_title' => $attributeTitlesValue->attribute)
			);

			foreach ($attributeValuesTitles as $attributeValuesKey => $attributeValue)
			{
				array_push(
					$attributes[$attributeTitlesKey],
					array('attribute_value' => $attributeValue->value)
				);
			}
		}
		
		// return $attributes;
		return array('attributes' => $attributes, 'typeID' => $typeID);
	}
}