<?php
class Invetory_model extends CI_Model {
	
	public function __construct()
	{
		$this->load->database();
		$this->load->library('session');
	}

	/*
	|-----------------------------------------------------------------------------------------------
	| Fetch all products categories
	|-----------------------------------------------------------------------------------------------
	*/
	public function get_product_categories()
	{
		$data = $this->db->get('product_category')->result();

		// Check if the query returns any records
		if ( ! empty($data) )
		{
			return $data;
		}
		else
		{
			return;
		}
	}

	/*
	|-----------------------------------------------------------------------------------------------
	| Fetch all products sub_categories
	|-----------------------------------------------------------------------------------------------
	*/
	public function get_product_sub_categories()
	{
		$data = $this->db->get('product_sub_category')->result();

		// Check if the query returns any records
		if ( ! empty($data) )
		{
			return $data;
		}
		else
		{
			return;
		}
	}

	/*
	|-----------------------------------------------------------------------------------------------
	| Fetch all products types
	|-----------------------------------------------------------------------------------------------
	*/
	public function get_product_types()
	{
		$data = $this->db->get('product_type')->result();

		// Check if the query returns any records
		if ( ! empty($data) )
		{
			return $data;
		}
		else
		{
			return;
		}
	}

	/*
	|-----------------------------------------------------------------------------------------------
	| Fetch all products from the database
	|-----------------------------------------------------------------------------------------------
	*/
	public function get_products()
	{
		// Ensure that the product table exists
		if ($this->db->table_exists('product'))
		{
			$data = $this->db->get('product')->result();

			// Check if the query returns any records
			if ( ! empty($data) )
			{
				return $data;
			}
			else
			{
				return;
			}
		}
		else
		{
			return;
		}
	}

	/*
	|---------------------------------------------------------------------------------------------
	| Fetch the user's tasks
	|---------------------------------------------------------------------------------------------
	*/
	public function get_tasks() {
		// check if tables exists
		if ($this->db->table_exists('tasks') )
		{
					 $this->db->order_by("id", "desc"); 
			$data  = $this->db->get('tasks')->result();

			// check if the query yeilds results
			if ( ! empty($data) )
			{
				$tasks = array();

				// define curent date
								date_default_timezone_set("Africa/Nairobi");
				$current_date = date("Ymd");
				
				$year 	= date('Y');
				$month 	= date('m');
				$day 	= date('d');

				// calculate duration
				foreach ($data as $key => $value)
				{
					$date_added = explode("-", $value->date_added);

					if ($year - $date_added[0] == 0)
					{
						// same year
					}
					if ($month - $date_added[1] == 0)
					{
						// same month
						$duration = $day - $date_added[2];
					}
					else
					{
						// different month
						// add the difference of days to the days in past months
						$duration = ($day - $date_added[2]) + (31 * ($month - $date_added[1]));
					}
					if ($day - $date_added[2] == 0)
					{
						// same day
						$duration = 0;
					}
					array_push($tasks, array(
						'id' 		=> $value->id,
						'task' 		=> $value->task,
						'duration' 	=> $duration
					));
				}
				return $tasks;
			}else
			{
				// no results found in the database
				return;
			}
		}else
		{
			// no table tasks was found
			return;
		}
	}

	/*
	|---------------------------------------------------------------------------------------------
	| Fetch the user's tasks
	|---------------------------------------------------------------------------------------------
	*/
	public function get_banners() {
		// check if tables exists
		if ($this->db->table_exists('banner') )
		{
			$data  = $this->db->get('banner')->result();

			// check if the query yeilds results
			if ( ! empty($data) )
			{
				return $data;
			}else
			{
				// no results found in the database
				return;
			}
		}else
		{
			// no table tasks was found
			return;
		}
	}

	/*
	|---------------------------------------------------------------------------------------------
	| Fetch all messages
	|---------------------------------------------------------------------------------------------
	*/
	public function get_messages() {
		// check if tables exists
		if ($this->db->table_exists('message') )
		{
			$data  = $this->db->get('message')->result();

			// check if the query yeilds results
			if ( ! empty($data) )
			{
				return $data;
			}else
			{
				// no results found in the database
				return;
			}
		}else
		{
			// no table tasks was found
			return;
		}
	}

	/*
	|--------------------------------------------------------------------------
	| Fetch the product attributes
	|--------------------------------------------------------------------------
	*/
	public function attributes($category, $subCategory, $type)
	{

		$attributes  = array();

		$category 	 = strtolower($category);
		$subCategory = strtolower($subCategory);
		$type 		 = strtolower($type);
		$category 	 = str_replace("%20", " ", $category);
		$subCategory = str_replace("%20", " ", $subCategory);
		$type 		 = str_replace("%20", " ", $type);

		$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
		$queryCategoryResult = $queryCategory->result();
		$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;

		$subCategoryArray 		 = array(
			'product_category_id'=> $CategoryID,
			'sub_category' 		 => $subCategory
		);
		$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
		$querysubCategoryResult  = $querysubCategory->result();
		$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
		
		$typeArray 	 = array(
			'product_category_id' 	  => $CategoryID,
			'product_sub_category_id' => $subCategoryID, 'type' => $type
		);	
		$querytype   = $this->db->get_where('product_type', $typeArray);
		$typeResult  = $querytype->result();
		$typeID	 	 = $typeResult[0]->product_type_id;

		$queryAttributes  = $this->db->get_where('product_attribute', array('product_type_id' => $typeID));
		$attributeTitles  = $queryAttributes->result();


		foreach ($attributeTitles as $attributeTitlesKey => $attributeTitlesValue)
		{
			$attribute = str_replace(" ", "_", $attributeTitlesValue->attribute);
			$attribute = str_replace("-", "_", $attribute);

			$queryAttributeValues  = $this->db->get_where(
									'product_attribute_'.$attribute,
									 array('product_type_id' => $typeID)
									);
			$attributeValuesTitles = $queryAttributeValues->result();

			array_push(
				$attributes,
				array('attribute_title' => $attributeTitlesValue->attribute)
			);

			foreach ($attributeValuesTitles as $attributeValuesKey => $attributeValue)
			{
				array_push(
					$attributes[$attributeTitlesKey],
					array('attribute_value' => $attributeValue->value)
				);
			}
		}
		
		// return $attributes;
		return array('attributes' => $attributes, 'typeID' => $typeID);
	}
}