<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Login extends MX_Controller
{
	public function __construct()
	{
		$this->load->helper(array('form', 'url'));
		$this->load->model('login_model');
		$this->load->library('session');
	}

	public function index($redirect = false)
	{
		// Ensure that the store table has been create
		if ($this->db->table_exists('store')) {
			
			$this->session->sess_destroy();
			$pageData['title'] = 'Dvee';

			if ($redirect !== false) {
				$pageData['redirect'] = $redirect;
			}
			$this->load->view('login_view', $pageData);
		} else {
			header('location: '.base_url().'welcome.html');
		}
	}

	public function authenticate($location = false)
	{
		// Load form library to validate form POST
		$this->load->library('form_validation');
		$this->form_validation->set_rules('username', 'Username', 'required');
		$this->form_validation->set_rules('password', 'Password', 'required');

		if ($this->form_validation->run() === FALSE) {
			$pageData['error'] 	= 'Missing username or password';
			$this->load->view('login_view', $pageData);
			// Destroy the session
			$this->session->sess_destroy();
		} else {
			// Get the username and password from the form POST
			$username = $this->input->post('username');
			$password  = $this->input->post('password');

			// if the user is valid
			if( $username AND $password
			AND $this->login_model->validate_user($username, $password)) {
				// redirect to appropriate page
				if ($location === false) {
					header("location: ".base_url()."panel.html");
				}else {
					$location = str_replace("-", "/", $location);
					header("location: ".base_url()."panel/".$location.".html");
				}
			} else {
	      		$pageData['title'] 		= 'Dvee';
	    		$pageData['error'] 		= 'invalid username or password';
	    		$pageData['redirect'] 	= $location;
	    		$this->load->view('login_view', $pageData);
			}
		}
	}
}