<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Panel extends MX_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->helper(array('form', 'url'));
		$this->load->model('panel_model');
		$this->load->library('session');
	}

	public function index()
	{
		// Ensure that the user is logged in
		if($this->session->userdata('isLoggedIn') == false) {
			header('location: '.base_url().'panel/login.html');
		} else {
			$data['title']    	= 'Dvee';
			$data['avatar']   	= '<img src="'.base_url().$this->session->userdata('avatar').'" />';
			$data['username'] 	= $this->session->userdata('username');
			$data['tasks'] 			= $this->panel_model->get_tasks();
			$data['num_of_items'] 	= count($this->panel_model->get_products());
			$data['num_of_banners'] = count($this->panel_model->get_banners());
			$data['num_of_messages'] = count($this->panel_model->get_messages());

			$this->load->view('panel_view', $data);
		}
	}

	public function settings($action = false)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "settings");
		} else {
			echo modules::run('settings/user/display');
		}
	}
}
