<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Products extends MX_Controller
{
	public function __construct() {
		parent::__construct();
		$this->load->model('panel_model');
		$this->load->helper(array('form', 'url'));
		$this->load->library('session');
	}

	public function index()
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products");
		} else {
			echo modules::run("inventory/items/display");
		}
	}

	public function add($value = FALSE)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products-add");
		} else {
			echo modules::run("inventory/items/add");
		}
	}

	public function edit($ID = FALSE)
	{
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products-edit-".$ID);
		} else {
			if ($ID == FALSE) {
				die("ERROR: Product not defined");
			} else {
				echo modules::run("inventory/items/edit", $ID);
			}
		}
	}

	public function categories() {
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products-categories");
		} else {
			echo modules::run("inventory/display/categories");
		}
	}

	public function banners($function = FALSE)
	{
		if($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "products-banners");
		} else {
			switch ($function) {
				case 'add':
					echo modules::run("inventory/add/banners");
					break;
				case 'delete':
					$ID = $this->uri->segment(5);
					echo modules::run("inventory/delete/banner", $ID);
					break;
				
				default:
					echo modules::run("inventory/display/banners");
					break;
			}		}
	}
}
