<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Category extends MX_Controller
{
	public function __construct()
	{
		parent::__construct();

		$this->load->model('category_model');
	}

			
	public function display()
	{
		$url   = $this->uri->segment(2);
		$value = explode("_", $url);

		if (count($value) === 3) {

			$data = $this->category_model->get_attributes($value);
			$data['category'] 	  = $value[0];
			$data['sub_category'] = $value[1];
			$data['type']  		  = $value[2];
			$data['other']    	  = modules::run('productDB/get/products');

			if (!isset($_SESSION)) {
				session_start();
			}

			if (isset($_POST['filter'])) {

				$category 	= $this->input->post('category');
				$attribute 	= $this->input->post('attribute');

				if (!in_array($attribute, $_SESSION['attributes'])) {
					array_push($_SESSION['attributes'], $attribute);
				} else {
					// remove existing attributes from filtering
					foreach ($_SESSION['attributes'] as $key => $value) {
						if ($attribute === $value) {
							unset($_SESSION['attributes'][$key]);
						}
					}
				}
				$data['products'] = $this->category_model->filter($category, $_SESSION['attributes']);

				$this->load->view('product_type.php', $data);
			} elseif (isset($_POST['refresh'])) {
				if (!isset($_SESSION)) {
					session_start();
				}
				if (isset($_SESSION['attributes'])) {
					$_SESSION['attributes'] = array();
				}
				$data['products'] = $this->category_model->get_by_type($value);
				$this->load->view('product_type.php', $data);
			} else {
				unset($_SESSION['attributes']);
				$_SESSION['attributes'] = array();
				

				$this->load->library('pagination');
				$config['base_url'] 	= base_url().'category/'.$value[0].'_'.$value[1].'_'.$value[2];
				$config['uri_segment'] 	= 3;
				$config['per_page'] 	= 20;
				$config['total_rows'] 	= $this->category_model->get_by_type_count($value);
				$config['num_links'] 	= round($config['total_rows'] / $config['per_page']);
				$config['full_tag_open']  = '<ul class="pagination">';
				$config['full_tag_close'] = '</ul>';
				$config['num_tag_open']   = '<li>';
				$config['num_tag_close']  = '</li>';
				$config['cur_tag_open']   = '<li class="active"><a>';
				$config['cur_tag_close']  = '</a></li>';
				$config['prev_tag_open']  = '<li class="prev">';
				$config['prev_tag_close'] = '</li>';
				$config['prev_link'] 	  = '← previous';
				$config['next_link'] 	  = 'Next →';
				$config['next_tag_open'] = '<li class="next">';
				$config['next_tag_close'] = '</li>';
				$this->pagination->initialize($config);
				
				$page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
				$data['products'] = $this->category_model->get_by_type($value, $config['per_page'], $page);
				$data['links'] = $this->pagination->create_links();

				$this->load->view('product_type.php', $data);
			}
		} else {
			$category = $value[0];
			$data = array();
			$data['category']   = $category;
			$data['images'] 	= $this->category_model->get_images($category);
			$data['categories'] = modules::run('productDB/get/menu', $category);
			$data['products']   = modules::run('productDB/get/category', $category, 10);
			$data['other'] 		= modules::run('productDB/get/other_categories', $category, 6);
			$data['latest'] 	= $this->category_model->latest($category);
			$data['more'] 		= $this->category_model->products(10);

			$this->load->view('product_category.php', $data);
		}
	}
}