<?php
class Category_model extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	public function filter($category, $attributes)
	{	
		$products = array();
		$segments = explode("_", $category);

		if (is_array($attributes) && !empty($attributes)) {
			// Ensure that the attributes are defined
			foreach ($attributes as $key => $attr) {
				if ($attr === "undefined" || strcmp($attr, "undefined") === 1) {
					// an attribute was not selected
				} else {
					$attributeDescription = explode("_", $attr);

					$attribute   = $attributeDescription[0];
					$attribute 	 = str_replace(" ", "_", $attribute);
					$attribute 	 = str_replace("-", "_", $attribute);
					$description = $attributeDescription[1];

					// Build a query that matches the selected attributes
					$this->db->where($attribute, $description);
				}
			}

			// Get the productIDs of the products that match the description
			$this->db->select('product_id'); 
			$qId  = $this->db->get_where('product_description')->result();

			// Use the IDs to get product information
			foreach ($qId as $key => $result) {
				$array['product_id'] 	= $result->product_id;
				$array['category'] 		= $segments[0];
				$array['sub_category'] 	= $segments[1];
				$array['type']			= $segments[2];
				$item  = $this->db->get_where('product', $array)->result();

				if (isset($item[0])) {
					array_push($products, $item[0]);
				}
			}
		} else {
			$products = $this->get_by_type(explode("_", $category));
		}
		return $products;
	}


	public function get_attributes($data)
	{
		$attributes  = array();

		if (isset($data[2]))
		{
			$category 		= str_replace("%20", " ", $data[0]);
			$subCategory 	= str_replace("%20", " ", $data[1]);
			$type 			= str_replace("%20", " ", $data[2]);

			$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
			$queryCategoryResult = $queryCategory->result();
			$categoryID		 	 = $queryCategoryResult[0]->product_category_id;
			$subCategoryArray 		 = array(
				'product_category_id'=> $categoryID,
				'sub_category' 		 => $subCategory
			);
			$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
			$querysubCategoryResult  = $querysubCategory->result();
			$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
			
			$typeArray 	 = array(
				'product_category_id' 	  => $categoryID,
				'product_sub_category_id' => $subCategoryID, 'type' => $type
			);	
			$querytype   = $this->db->get_where('product_type', $typeArray);
			$typeResult  = $querytype->result();
			$typeID	 	 = $typeResult[0]->product_type_id;
		}
		else
		{
			$productInfo = $this->db->get_where('product', array('product_id' => $slug))->result();
			$category 	 = $productInfo[0]->category;
			$subCategory = $productInfo[0]->sub_category;
			$type 		 = $productInfo[0]->type;

			$queryCategory   	 = $this->db->get_where('product_category', array('category' => $category));
			$queryCategoryResult = $queryCategory->result();
			$CategoryID		 	 = $queryCategoryResult[0]->product_category_id;

			$subCategoryArray 		 = array(
				'product_category_id'=> $CategoryID,
				'sub_category' 		 => $subCategory
			);
			$querysubCategory   	 = $this->db->get_where('product_sub_category', $subCategoryArray);
			$querysubCategoryResult  = $querysubCategory->result();
			$subCategoryID		 	 = $querysubCategoryResult[0]->product_sub_category_id;
			
			$typeArray 	 = array(
				'product_category_id' 	  => $CategoryID,
				'product_sub_category_id' => $subCategoryID, 'type' => $type
			);	
			$querytype   = $this->db->get_where('product_type', $typeArray);
			$typeResult  = $querytype->result();
			$typeID	 	 = $typeResult[0]->product_type_id;
		}




		$queryAttributes  = $this->db->get_where('product_attribute', array('product_type_id' => $typeID));
		$attributeTitles  = $queryAttributes->result();

		foreach ($attributeTitles as $attributeTitlesKey => $attributeTitlesValue)
		{
			$attribute = str_replace(" ", "_", $attributeTitlesValue->attribute);
			$attribute = str_replace("-", "_", $attribute);

			$queryAttributeValues  = $this->db->get_where(
									'product_attribute_'.$attribute,
									 array('product_type_id' => $typeID)
									);
			$attributeValuesTitles = $queryAttributeValues->result();

			array_push(
				$attributes,
				array('attribute_title' => $attributeTitlesValue->attribute)
			);

			foreach ($attributeValuesTitles as $attributeValuesKey => $attributeValue)
			{
				array_push(
					$attributes[$attributeTitlesKey],
					array('attribute_value' => $attributeValue->value)
				);
			}
		}
		
		// return $attributes;
		return array('attributes' => $attributes, 'typeID' => $typeID);
	}

	public function get_by_type_count($category)
	{
		$array['category'] 		= $category[0];
		$array['sub_category'] 	= $category[1];
		$array['type'] 			= $category[2];

		$result = $this->db->get_where('product', $array)->result();
		return count($result); 
	}

	public function get_by_type($category, $limit, $start)
	{
		$array['category'] 		= $category[0];
		$array['sub_category'] 	= $category[1];
		$array['type'] 			= $category[2];
		
				  $this->db->limit($limit, $start);
		$query = $this->db->get_where('product', $array);
		foreach ($query->result() as $row) {
			$data[] = $row;
		}
		return $data;
	}

	public function get_images($category)
	{
		$array['category'] = $category;
		
		$this->db->order_by("product_id", "random"); 
		return $this->db->get_where('banner', $array)->result();
	}

	public function latest($category)
	{
		//get category type of latest item
		$array  = array('category' => $category);
				  $this->db->order_by("product_id", "desc"); 
		$query 	= $this->db->get_where('product', $array)->result();
		
		if (isset($query[0])) {
			$cat 	= $query[0]->category;
			//get 3 items of latest category
			$array  = array('category' => $cat);
					  $this->db->limit(3); 
			$query 	= $this->db->get_where('product', $array)->result();
			
			return $query;
		} else {
			// no items found
			return false;
		}

	}

	public function products($limit)
	{
				  $this->db->limit($limit);
				  $this->db->order_by("product_id", "RANDOM");
		$query 	= $this->db->get_where('product')->result();

		return $query;
	}
}