<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Get extends MX_Controller
{
	public function __construct()
	{
		parent::__construct();

		$this->load->model('product_model');
	}

	public function products($id = false )
	{
		return $this->product_model->get($id = false );
	}

	public function details($ID = FALSE, $option = FALSE)
	{
		if ($ID == FALSE) {
			echo "ERROR: Product not defined";
		} else {
			$data['product'] = $this->product_model->getDetails($ID, $option);
			$data['related'] = $this->product_model->get_related_products($data['product']['type']);

			return $data;
		}
	}

	public function category($category = false, $num = false)
	{
		$this->load->model('categories_model');
		return $this->categories_model->get_by_category($category, $num);
	}

	public function full_category($category = false, $num = false)
	{
		$this->load->model('categories_model');

		if ($category == false) {
			die('productDB ERROR: product not set');
		} else {
			return $this->categories_model->get_by_full_category($category, $num);
		}
	}

	public function type($category = false, $num = false)
	{
		$this->load->model('categories_model');

		if ($category == false) {
			die('productDB ERROR: product not set');
		} else {
			return $this->categories_model->get_by_type($category, $num);
		}
	}
	
	public function other_categories($category, $limit)
	{
		$this->load->model('categories_model');
		return $this->categories_model->get_other_categories($category, $limit);
	}

	public function menu($category = false)
	{
		$this->load->model('categories_model');
		return $this->categories_model->menu_by_category($category);
	}


	/*
	|-----------------------------------------------------------------------------------------------
	| Fetch a product's quantity
	|-----------------------------------------------------------------------------------------------
	*/
	public function quantity($data = FALSE)
	{
		if ($data == FALSE) {
			echo false;
		} else {
			$values = explode("_", $data);
			$ID 	= $values[0];
			$size 	= $values[1];
			$color  = $values[2];
		}

		echo $this->product_model->getProductQuantity($ID, $size, $color);
	}

	public function cart()
	{
		$this->load->library('cart');

		$data['id']      = $_POST['ID'];
		$data['qty']     = $_POST['quantity'];
		$data['price']   = $_POST['price'];
		$data['name']    = $_POST['name'];
		$data['options']['size']  = $_POST['size'];
		$data['options']['color'] = $_POST['color'];
		$data['options']['thumb'] = $_POST['thumb'];

		$this->cart->insert($data);

		echo count($this->cart->contents());
	}
}