<?php
class Categories_model extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	public function get_by_category($category, $num = false)
	{
		$array = array('category' => $category);

		$this->db->limit($num);
		$this->db->order_by("product_id", "random"); 
		return $this->db->get_where('product', $array)->result();
	}

	public function get_by_full_category($category, $num = false)
	{
		$segement = explode("_", $category);
		$array 	  = array(
			'category' 		=> $segement[0],
			'sub_category' 	=> $segement[1],
			'type' 			=> $segement[2]);

		if ($num) {
			$this->db->limit($num);
		}
		$this->db->order_by("product_id", "random"); 
		return $this->db->get_where('product', $array)->result();
	}
	
	public function menu_by_category($category)
	{
		$result = array();

		if ($category === false) {
			$cat = $this->db->get('product_category')->result();
		} else {
			$array = array('category' => $category);
			$cat = $this->db->get_where('product_category', $array)->result();
		}	
		foreach ($cat as $Ckey => $category) {

			array_push($result, array('category' => $category->category));

			$array  = array('product_category_id' => $category->product_category_id);
			$subCat = $this->db->get_where('product_sub_category', $array)->result();

			foreach ($subCat as $subKey => $sub) {
				
				$array = array('sub_category' => $sub->sub_category);

				array_push($result[$Ckey], $array);

				$array = array('product_sub_category_id'=>$sub->product_sub_category_id);
				$types = $this->db->get_where('product_type', $array)->result();

				foreach ($types as $types_key => $types_value) {
					
					array_push($result[$Ckey][$subKey], $types_value->type);
				}
			}
		}
		return $result;
	}

	public function get_other_categories($category, $limit)
	{
		// Get all product categories at random
				  $this->db->order_by('product_category_id', 'RANDOM');
		$cat    = $this->db->get('product_category')->result();
		$result = array(); 

		foreach ($cat as $key => $value) {
			if ($value->category !== $category) {
				// Get the products from each random category
				$array	  = array('category' => $value->category);
							// $this->db->limit($limit);
				$products = $this->db->get_where('product', $array)->result();
				
				if (!empty($products)) {
					$array['category'] = $value->category;
					$array['products'] = $products;
					array_push($result, $array);
				}
			}
		}
		return $result;
	}
}