<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Search extends MX_Controller
{
	public function __construct() {
		parent::__construct();
		$this->load->model("search_model");
	}

	public function index()
	{
		
		// ensure that a search query has been entered
		if (isset($_POST['search'])) {

			$search_term 	 	  = $this->input->post('search');
			$search_results 	  = $this->search_model->query($search_term);
			$data['query'] 	 	  = $search_term;
			$data['products'] 	  = $search_results['product'];
			$data['types'] 		  = $search_results['type'];
			$data['category'] 	  = $search_results['category'];
			$data['sub_category'] = $search_results['sub_category'];
			$category 	 	  	  = $this->input->post('category');
			$data['categories']   = $search_results['product_categories'];
			$data['filtered'] 	  = false;
			$data['selected'] 	  = false;
			$data['other']  	  = modules::run('productDB/get/products');
			$this->load->view('search_view', $data);
			
		} elseif (isset($_POST['filter'])) {
			$search_term 	 	  = $this->input->post('query');
			$category 	 	  	  = $this->input->post('category');
			$search_results 	  = $this->search_model->query($search_term, $category);
			$data['query'] 	 	  = $search_term;
			$data['products'] 	  = $search_results['product'];
			$data['types'] 		  = $search_results['type'];
			$data['category'] 	  = $search_results['category'];
			$data['sub_category'] = $search_results['sub_category'];
			$data['categories']   = $search_results['product_categories'];
			$data['filtered'] 	  = $search_results['filtered'];
			$data['selected'] 	  = str_replace("_", " > ", $category);
			$data['other']  	  = modules::run('productDB/get/products');

			$this->load->view('search_view', $data);
		}
	}
}
