<?php echo modules::run('template/serve/header'); ?>

<?php if ($products === false || empty($products)): ?>
	<!-- Products 404 -->
	<div class="row">
		<div class="col-xs-12">
			<div class="well text-center">
				<h4>
					No matches for
					<span class="text-danger"><?php echo $query; ?></span>
				</h4>
			</div>
		</div>
		<div class="col-xs-12 text-center">
			<img src="<?php echo base_url(); ?>assets/images/empty_box.jpg" alt="">
			<div style="margin-top:20px;margin-bottom: 185px">
				<button class="btn btn-default" id="go-to-other">
					<i class="fa fa-arrow-down"></i> &nbsp other products
				</button>
			</div>
		</div>
	</div>
<?php else: ?>
	<div class="row">
		<div class="well text-center">
			<h4>
				<?php echo form_open('search'); ?>
					<input type="hidden" name="search" value="<?php echo $query; ?>">
					Search results for
					<button type="submit" style="border:0;padding:0;background:none">
						<span class="text-danger">
							<u><?php echo $query; ?></u>
						</span>
					</button>
				</form>
			</h4>
			<?php if ($selected): ?>
				<span class="text-success">Showing in </span>
				<span class="text-primary"><?php echo $selected ?></span>
			<?php endif ?>
		</div>
	</div>
	<div class="container" style="float:none;margin:0 auto">
		<div class="row">

			<!-- left filter -->
			<div class="col-xs-12 col-sm-4 col-md-4 col-lg-3">
				<div class="row">
					<div class="col-xs-12">
						<button class="btn btn-custom btn-lg visible-xs" id="filter-btn">
							<i class="fa fa-sort"></i> &nbsp Filter
						</button>
					</div>
					<div class="col-md-12" id="filter-page">
                    	<h4 class="text-right">
                    		<div class="pull-left">
		                    	Filter results &nbsp
		                    	<span class="label label-warning"><?php echo count($products) ?></span>
                    		</div>
	                    	<?php echo form_open('search'); ?>
								<input type="hidden" name="search" value="<?php echo $query; ?>">
								<button type="submit" style="border:0;padding:0;background:none">
									<i class="fa fa-refresh"></i>
								</button>
							</form>
                    	</h4>
	        			<?php foreach ($categories as $key => $value): ?>

	        			<?php if (in_array($value['category'], array_keys($category))): ?>
							<div class="panel panel-default" style="margin-bottom:20px">
				                <div class="well panel-heading" style="background:#F5F5F5;padding-right:0">
									<span class="text-primary">
					                <?php echo strtoupper($value['category']) ?> &nbsp
									</span>
									<span class="label label-primary pull-right">
										<?php echo count($category[$value['category']]) ?>
									</span>
									<div class="clear-fix"></div>
				                </div>

				                <div class="panel-body" style="padding:0">
				                    <div>
				                    	<?php
		        						// create a unique valid id for javascript collapse plugin
		        						$CatId = str_replace(" ", "", $value['category']);
		        						$CatId = str_replace("'", "", $CatId);
		        						$CatId = str_replace("_", "-",$CatId);
		        						?>
				                    	<div class="panel-group" id="<?php echo $CatId ?>">
						        			<?php foreach ($value as $key => $subCat): ?>
				        						<?php if (is_array($subCat) && in_array($subCat['sub_category'], array_keys($sub_category))): ?>
				        						<?php if ($value['category'] === $sub_category[$subCat['sub_category']][0]['category']
				        						&& $subCat['sub_category'] === $sub_category[$subCat['sub_category']][0]['sub_category']): ?>
				        						<?php
				        						// create a unique valid id for javascript collapse plugin
				        						$subCatId = str_replace(" ", "", $subCat['sub_category']);
				        						$subCatId = str_replace("'", "", $subCatId);
				        						$subCatId = str_replace("_", "-",$subCatId);
				        						?>
													<div class="panel panel-default">
														<div class="panel-heading">
															<div class="panel-title" data-toggle="collapse" data-parent="#<?php echo $CatId ?>" href="#<?php echo $subCatId ?>">
																<i class="fa fa-sort"></i>&nbsp
																<?php echo $subCat['sub_category'] ?>
																<span class="label label-default">
																	<?php echo count($sub_category[$subCat['sub_category']]) ?>
																</span>
															</div>
														</div>
														<?php if ($key === 0): ?>
															<div id="<?php echo $subCatId ?>" class="panel-collapse collapse">
														<?php else: ?>
															<div id="<?php echo $subCatId ?>" class="panel-collapse collapse">
														<?php endif ?>
															<div class="panel-body">
										                        <?php for ($i=0; $i < count($subCat)-1; $i++): ?>
											                        <?php if (in_array($subCat[$i], array_keys($types))): ?>
											                        <?php if ($value['category'] === $types[$subCat[$i]][0]['category'] &&
											                        $subCat['sub_category'] === $types[$subCat[$i]][0]['sub_category'] &&
											                        $subCat[$i] === $types[$subCat[$i]][0]['type']): ?>
											                        	<?php echo form_open('search') ?>
																			<input type="hidden" name="query" value="<?php echo $query ?>"/>
																			<input type="hidden" name="category" value="<?php echo $value['category'] ?>_<?php echo $subCat['sub_category'] ?>_<?php echo $subCat[$i] ?>"/>
																			<button type="submit" name="filter" class="select">
																				<?php echo $subCat[$i] ?> &nbsp
																				<span class="label label-default">
																					<?php echo count($types[$subCat[$i]]) ?>
																				</span>
																			</button>
																		</form>
											                        <?php endif ?>
											                        <?php endif ?>
										                        <?php endfor; ?>
															</div>
														</div>
													</div>
									            <?php endif ?>
									            <?php endif ?>
						        			<?php endforeach; ?>
										</div>
				                    </div>
				                </div>
				            </div>
			            <?php endif ?>
			            <?php endforeach; ?>
	                    <div class="row">
	                    	<div class="col-xs-12">
		                    	<div class="panel panel-default">
		                    		<div class="panel-heading text-center" style="background:0;color:#333;">
			                    		Price range
			                    	</div>
			                    	<div class="panel-body">
			                    		<input type="range" min="10" max="100" value="0" />
			                    	</div>
		                    	</div>
		                    </div>
	                    </div>
					</div>
				</div>
			</div>

			<!-- display products -->
			<div class="col-xs-12 col-sm-8 col-md-8 col-lg-9">
	            <?php if ($filtered): ?>
	            	<?php echo modules::run("template/serve/product_tiles", $filtered); ?>
	            <?php else: ?>
	            	<?php echo modules::run("template/serve/product_tiles", $products); ?>
	            <?php endif ?>
			</div>
		</div>
	</div>
<?php endif; ?>

<div class="container">
	<hr style="margin-top:150px">
    <br>
    <h3 id="other" style="text-align:center">Check out other products</h3>
    <br><br>
</div>
<div class="container">
	<?php echo modules::run("template/serve/product_tiles", $other, 'carousel'); ?>
</div>



<script>
	$('#go-to-other').click(function(){
        $('html,body').animate({
            scrollTop: $("#other").offset().top-10
        }, 1000);
    });
	$('#filter-btn').click(function(){
		toggleFilter($('#filter-page'));
	});

	function toggleFilter(page) {
		if (page.hasClass('toggle')) {
			page.stop().animate({maxHeight:0}, 1000);
			page.removeClass('toggle');
		} else {
			page.stop().animate({maxHeight:1000}, 1000);
			page.addClass('toggle');
		}
	}
</script>

<?php echo modules::run('template/serve/footer'); ?>