<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Messages extends MX_Controller
{
	// Deny direct access
	function _remap()
	{
		show_404();
	}

	public function __construct() {
		parent::__construct();
		$this->load->helper(array('form', 'url'));
		$this->load->library('session');
		$this->load->model('message_model');
	}

	public function index()
	{
		// Ensure that the user is logged in
		if ($this->session->userdata('isLoggedIn') == false) {
			echo modules::run("panel/login/index", $redirect = "messages");
		} else {
			$pageData['title']    = 'Dvee';
			$pageData['avatar']   = '<img src="'.base_url().$this->session->userdata('avatar').'" />';
			$pageData['username'] = $this->session->userdata('username');

			$this->load->view('messages_view', $pageData);
		}
	}

	public function open($ID = FALSE)
	{
		$database_result = $this->message_model->open_message($ID);
		$data['message'] = $database_result['message'];
		$data['product'] = $database_result['product'];

		$this->load->view('details_view', $data);
	}

	public function inbox()
	{
		$data['title'] 		= 'inbox';
		$data['messages'] 	= $this->message_model->get_messages('inbox');

		$this->load->view('folder_view', $data);
	}

	public function sent()
	{
		$data['title'] 		= 'sent';
		$data['messages'] 	= $this->message_model->get_messages('sent');

		$this->load->view('folder_view', $data);
	}

	public function deleted()
	{
		$data['title'] 		= 'deleted';
		$data['messages'] 	= $this->message_model->get_messages('deleted');

		$this->load->view('folder_view', $data);
	}

	public function trash($ID = FALSE)
	{
		$this->message_model->trash_message($ID);
	}

	public function delete($ID = FALSE)
	{
		$this->message_model->delete_message($ID);
	}

	public function restore($ID = FALSE)
	{
		$this->message_model->restore_message($ID);
	}
}