<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Document</title>
	<link rel="stylesheet" type="text/css" href="<?php echo base_url()?>assets/css/datatables/dataTables.bootstrap.css" rel="stylesheet"/>
</head>
<body>

<div class="row">
    <div class="col-md-12 animated fadeIn">
        <?php
        if ($messages == FALSE) { ?>
            <h4 style="text-align:center;color:#777" class="animated fadeIn">
                <br><br>
                <i class="fa fa-info-circle"></i> &nbsp &nbsp
                you have no <?php echo $title ?> messages
                <br><br>
                <img src="<?php echo base_url(); ?>assets/images/empty_box.jpg" alt="">
            </h4>
            <br><br>
        <?php } else { ?>
            <div class="col-md-12" style="margin-top:20px">
                <table id="item-table" class="table table-hover">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>type</th>
                            <th>title</th>
                            <th>date-added</th>
                        </tr>
                    </thead>

                    <tbody>
                        <?php foreach ($messages as $key => $message){ ?>
                        <tr class="open-message" message-number="<?php echo $message->message_id; ?>">
                            <td><?php echo $message->name; ?></td>
                            <td>
                            	<?php if ($message->type == 'inquiry'): ?>
                            		<span class="label label-primary"> <?php echo $message->type ?> </span>
                            	<?php endif ?>
                            </td>
                            <td><?php echo $message->title; ?></td>
                            <td><?php echo $message->date_added; ?></td>
                        </tr>
                        <?php } ?>
                    </tbody>
                </table>
            </div>
            <br><br>
        <?php } ?>
    </div>
</div>

<script type="text/javascript" src="<?php echo base_url()?>assets/js/datatables/jquery.dataTables.js"></script>
<script type="text/javascript" src="<?php echo base_url()?>assets/js/datatables/dataTables.bootstrap.js"></script>
<!-- data tables -->
<script type="text/javascript" language="javascript" class="init">
    $(document).ready(function() {

        $('#item-table').dataTable({
            "bPaginate": true,
            "bLengthChange": true,
            "bFilter": true,
            "bSort": true,
            "bInfo": true,
            "bAutoWidth": false
        });
    });
</script>

<script>
    $('.open-message').click(function(){
        var ID = $(this).attr('message-number');
        $.ajax({
            url: "<?php echo base_url() ?>panel/mail_box/open/"+ID,
            cache: true,
            beforeSend: function()
            {
                display.stop().animate({
                    opacity: 0.2
                }, 700);
                $('#folder-loader').show();
            },
            success: function(html)
            {
                display.stop().animate({
                    opacity: 1
                }, 700);
                $('.cotent-nav-btn').removeClass('active');
                $('#folder-loader').hide();
                display.html(html);
            },
            complete: function(){},
            error: function(){
                display.stop().animate({
                    opacity: 1
                }, 3000);

                $('#folder-loader').html('<i class="fa fa-warning"></i>');
                setTimeout(function(){
                    $('#folder-loader').html('<i class="fa fa-spinner"></i>');
                    $('#folder-loader').hide();
                }, 2500);
            }
        });
    });
</script>



</body>
</html>